Package ghidra.app.util.bin.format.macho.dyld

# Class DyldCacheMappingInfo

java.lang.Object
ghidra.app.util.bin.format.macho.dyld.DyldCacheMappingInfo

All Implemented Interfaces:
  `StructConverter`

public class DyldCacheMappingInfo extends Object implements StructConverter
Represents a dyld_cache_mapping_info structure.

See Also:
  - dyld_cache_format.h

- ## Field Summary

  ### Fields inherited from interface ghidra.app.util.bin.StructConverter

  `ASCII, BYTE, DWORD, IBO32, IBO64, POINTER, QWORD, SLEB128, STRING, ULEB128, UTF16, UTF8, VOID, WORD`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DyldCacheMappingInfo(BinaryReader reader)`
  Create a new `DyldCacheImageInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `contains(long addr)`
  Returns true if the mapping contains the given address
  `long`
  `getAddress()`
  Gets the address of the start of the mapping.
  `long`
  `getFileOffset()`
  Gets the file offset of the start of the mapping.
  `long`
  `getSize()`
  Gets the size of the mapping.
  `boolean`
  `isExecute()`
  Returns true if the initial protections include EXECUTE.
  `boolean`
  `isRead()`
  Returns true if the initial protections include READ.
  `boolean`
  `isWrite()`
  Returns true if the initial protections include WRITE.
  `DataType`
  `toDataType()`
  Returns a structure datatype representing the contents of the implementor of this interface.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### DyldCacheMappingInfo

    public DyldCacheMappingInfo(BinaryReader reader) throws IOException
    Create a new `DyldCacheImageInfo`.
    Parameters:
      `reader` - A `BinaryReader` positioned at the start of a DYLD mapping info
    Throws:
      `IOException` - if there was an IO-related problem creating the DYLD mapping info

- ## Method Details

  - ### getAddress

    public long getAddress()
    Gets the address of the start of the mapping.
    Returns:
      The address of the start of the mapping

  - ### getSize

    public long getSize()
    Gets the size of the mapping.
    Returns:
      The size of the mapping

  - ### getFileOffset

    public long getFileOffset()
    Gets the file offset of the start of the mapping.
    Returns:
      The file offset of the start of the mapping

  - ### isRead

    public boolean isRead()
    Returns true if the initial protections include READ.
    Returns:
      true if the initial protections include READ

  - ### isWrite

    public boolean isWrite()
    Returns true if the initial protections include WRITE.
    Returns:
      true if the initial protections include WRITE

  - ### isExecute

    public boolean isExecute()
    Returns true if the initial protections include EXECUTE.
    Returns:
      true if the initial protections include EXECUTE

  - ### contains

    public boolean contains(long addr)
    Returns true if the mapping contains the given address
    Parameters:
      `addr` - The address to check
    Returns:
      True if the mapping contains the given address; otherwise, false

  - ### toDataType

    public DataType toDataType() throws DuplicateNameException, IOException
    Description copied from interface: `StructConverter`
    Returns a structure datatype representing the contents of the implementor of this interface.

    For example, given:

         class A {
             int foo;
             double bar;
         }

    The return value should be a structure data type with two data type components; an INT and a DOUBLE. The structure should contain field names and, if possible, field comments.

    Specified by:
      `toDataType` in interface `StructConverter`
    Returns:
      returns a structure datatype representing the implementor of this interface
    Throws:
      `DuplicateNameException` - when a datatype of the same name already exists
      `IOException`
    See Also:
      - `StructureDataType`